<?php

$xhe_host = "127.0.0.1:7010";

// init
require("../../Templates/init.php");

// название файла с данными
$receipt_name = "kvitancia.jpg";
// ////
// режим отладки
$dbg = true;
$debug_file = 'log/log_' . date("d_m_y") . '.txt';

// //////////////////////// дополнительные модули ///////////////
// функции 
require_once("tools/functions.php");

// /////////////////////// скрипт ///////////////////////////////////////////
debug_mess("запустили робота");

// получим путь к папке с роботом
$robot_folder = $debug->get_cur_script_folder();
debug_mess("Путь к папке с роботом: " . $robot_folder);

// получим путь к папке data
$data_path = $robot_folder . 'data\\';
debug_mess("Путь к папке с данными: " . $data_path);

// получим путь к файлу с данными (квитанции)
$receipt_path = $data_path . $receipt_name;
debug_mess("Полный путь к платежке: " . $receipt_path);

// проверка на наличие файла с данными
if (!$file_os->is_exist($receipt_path))
{
	debug_mess("ОШИБКА: Нет файла с данными!");
	$app->quit();
}
// масштабируем картинку
$scale = 2;
$image->resize($receipt_path, $receipt_path.".resized.jpg", $scale);
// удаляем линии из картинки
$image->remove_lines($receipt_path.".resized.jpg", $receipt_path.".without_lines.jpg");
$path = $receipt_path . ".without_lines.jpg";

// распознаем картинку целиком -------------------------------------------------------------
debug_mess("1. Распознавание всего текста квитанции");
$str_receipt = "";
$str_receipt = $tesseractOCR->recognize($path, "rus+eng", 5);
echo $str_receipt . "<br>";
debug_mess( "------------------------------------");

// получаем ИНФО
$str_receipt = get_string($str_receipt, "porfjilkom.ru", "на");
//echo "<br>ИНФО: " . $str_receipt . "<br>";

// преобразуем строку в массив
$arr_receipt = [];
$arr_receipt = explode("\n", $str_receipt);
//print_r($arr_receipt);

// получаем ФИО адрес
$fio_and_adress = "";
$fio_and_adress = explode(" ", $arr_receipt[0]);
$fio = "";
$fio = $fio_and_adress[0]." ".$fio_and_adress[1]." ".$fio_and_adress[2];
$addr = $fio_and_adress[3] . " " . $fio_and_adress[4] . " " . $fio_and_adress[5] . " " . $fio_and_adress[6] . " " . $fio_and_adress[7];
debug_mess( "Плательщик: " . $fio . " " . $addr);

// получаем сумму платежа
$summa = $arr_receipt[1];
debug_mess ("Сумма: " . $summa);

// получаем номер лицевого счета
$pers_acc = $arr_receipt[6];
debug_mess ("№ лиц. счета: " . $pers_acc);
// завершение распознавания картинки целиком ------------------------------------------

// распознавание регионов
debug_mess("--------------------------------------------------------------------");
debug_mess("2. Распознавание текста по областям картинки квитанции, выделенным OCR");
// PageIteratorLevel { Block = 0, Para = 1, TextLine = 2,  Word = 3,  Symbol = 4
$r = $tesseractOCR->get_segmented_regions($path,"rus+eng", 2); 
$str_receipt = [];
//print_r($r);
if ($r !== null && $r->items !== null)
{ 
	for ($ii = 0; $ii < count($r->items); $ii++)
	{
		$image->get_image($path, $path."_line_$ii.png", $r->items[$ii]->X, $r->items[$ii]->Y, $r->items[$ii]->Width, $r->items[$ii]->Height);                         
		$str_receipt[$ii] = $tesseractOCR->recognize($path."_line_$ii.png", "rus"); // распознаем          
		//debug_mess($ii." => ".$str_receipt[$ii]);
	} // for $ii regions
	 // получатель
	 debug_mess($str_receipt[12] . $str_receipt[13] . ": ");
	 debug_mess($str_receipt[27]);
	 debug_mess($str_receipt[28]);
	 debug_mess($str_receipt[29]);
	 debug_mess($str_receipt[30]);
	 debug_mess($str_receipt[31]);
	 // плательщик
	debug_mess($str_receipt[14] . ": ");
	$fio_addr = [];
	$fio_addr = explode(" ", $str_receipt[32]);
	$fio = $fio_addr[0] . " " . $fio_addr[1] . " " . $fio_addr[2];
	$addr = $fio_addr[3] . " " . $fio_addr[4] . " " . $fio_addr[5] . " " . $fio_addr[6] . " " . $fio_addr[7];
	debug_mess($fio .  // ФИО
	" " . $addr ); // адрес
	// сумма
	debug_mess("Сумма: " . $str_receipt[33]);
   // номер лицевого счета
	debug_mess($str_receipt[35] . ": " . $str_receipt[36]);

	for ($ii = 0; $ii < count($r->items); $ii++)
	{
		$file_os->delete($path  . "_line_$ii.png");                         
	}
} // if $r && $r->items
// завершение распознавания регионов  -----------------------

// распознавание областей, вручную выделенных на картинке квитанции
debug_mess("<hr>");
debug_mess("3. Распознавание областей, вручную выделенных на картинке квитанции");

$image->get_image($path, $path . "___1.jpg", 561, 763, 329, 155); // x, y, with, height
$text = $tesseractOCR->recognize($path . "___1.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___1.jpg");
$recipient_title = $text;

$image->get_image($path, $path . "___2.jpg", 924, 759, 1222, 272); // x, y, with, height
//$image->preprocess_for_ocr($path . "___2.jpg", $path . "___2.jpg");
$text = $tesseractOCR->recognize($path . "___2.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___2.jpg");
$recipient_data = $text;

$image->get_image($path, $path . "___3.jpg", 567, 1022, 323, 102); // x, y, with, height
$text = $tesseractOCR->recognize($path . "___3.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___3.jpg");
$payer_title = $text;

$image->get_image($path, $path . "___4.jpg", 926, 1007, 1439, 111); // x, y, with, height
$text = $tesseractOCR->recognize($path . "___4.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___4.jpg");
$payer_data = $text;

$image->get_image($path, $path . "___5.jpg", 578, 1214, 248, 68); // x, y, with, height
$text = $tesseractOCR->recognize($path . "___5.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___5.jpg");
$payment_title = $text;

$image->get_image($path, $path . "___6.jpg", 918, 1205, 204, 79); // x, y, with, height
$text = $tesseractOCR->recognize($path . "___6.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___6.jpg");
$payment = $text;

$image->get_image($path, $path . "___7.jpg", 2314, 761, 285, 64); // x, y, with, heig
$text = $tesseractOCR->recognize($path . "___7.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___7.jpg");
$account_title = $text;

$image->get_image($path, $path . "___8.jpg", 2325, 820, 278, 66 ); // x, y, with, heig
$text = $tesseractOCR->recognize($path . "___8.jpg", "rus+eng"); // распознаем
$file_os->delete($path . "___8.jpg");
$account_no = $text;

// получатель
debug_mess($recipient_title . ": " . $recipient_data);

// плательщик
debug_mess($payer_title . ": ");
$fio_addr = [];
$fio_addr = explode(" ", $payer_data);
// его ФИО и адрес
debug_mess($fio_addr[0] . " " . $fio_addr[1] . " " . $fio_addr[2] . // ФИО
" " . $fio_addr[3] . " " . $fio_addr[4] . " " . $fio_addr[5] . " " . $fio_addr[6] . " " . $fio_addr[7]); // адрес
// сумма
debug_mess($payment_title . ": " . $payment);
// номер лицевого счета
debug_mess($account_title . ": " . $account_no);

$file_os->delete($data_path . "kvitancia.jpg.resized.jpg");
$file_os->delete($data_path . "kvitancia.jpg.without_lines.jpg");
$file_os->delete($data_path . "kvitancia.jpg.resized.jpg kvitancia.jpg.without_lines.jpg");

debug_mess("робот закончил работу");

// Quit */
$app->quit();
?>